#include "init.h"
/*
TINY 24 running at internal RC @ 8MHz

PINOUT:
 PA7: ICP	Servo 1 in
 PA6: OC1A	Servo 1 out
 PA5: OC1B	Servo 2 out
 PA4: PCint	Servo 2 in
 PA3: Stop engine (high active)
 PA2: free
 PA1: ADC1	V_in 1/11
 PA0: free

 PB2: OC0A	chargepump
 PB1: free
 PB0: LED (low active)

*/

void init ( void ) {

	PORTA	= (1<<PA7) | (1<<PA4) | (1<<PA3) | (1<<PA2) | (1<<PA0);
	DDRA	= (1<<PA6) | (1<<PA5) | (1<<PA3);

	PORTB	= (1<<PB0);
	DDRB	= (1<<PB0);

	// Timer0 for chargepump
	//  no prescaler, Fast-PWM, non-inverting OC0A
	TCCR0A	= (1<<COM0A1) | (1<<WGM01) | (1<<WGM00);
	TCCR0B	= (1<<CS00);
	OCR0A	= 127;

	// Timer1 for Servosetting
	//  clk/8 (1MHz), Normal-Mode, no PWM
	TCCR1A	= (1<<COM1A1) | (1<<COM1B1);
	TCCR1B	= (1<<ICNC1) | (1<<ICES1) | (1<<CS11);
	TIMSK1	= (1<<ICIE1) | (1<<OCIE1B) | (1<<OCIE1A) | (1<<TOIE1);

	TIFR1	= 0xFF;
	sei();
}
