#include "interrupts.h"



ISR ( TIM1_CAPT_vect ) {
	static uint16_t pos_edge = 0;
	uint16_t time = 0;

	
	if ( TCCR1B	& (1<<ICES1) ) {	// Wenn auf steigende Flanke getriggert wurde
		TCCR1B	&= ~(1<<ICES1);		//  Auf fallende Flanke triggern
		TIFR1	= (1<<ICF1);		//  Flag lschen wie im DB nach Flankenwechsel gefordert
		pos_edge = ICR1;			//  Merken wann die Flanke war
		led_an();	// LED zum debuggen an
	}
	else {							// sonst
		TCCR1B	|= (1<<ICES1);		//  wieder auf steigende Flanke triggern
		TIFR1	= (1<<ICF1);		//  Flag lschen wie im DB nach Flankenwechsel gefordert
		time = ICR1 - pos_edge;		//  +Pulsbreite berechnen
		if ( time > 900 && time < 1500 ) { // Pulsbreite berprfen und ggf. bernehmen
			read_pos = time;
			sig_good_cnt = 0;
		}
		led_aus();	// LED zum debuggen aus
	}
}


ISR ( TIM1_OVF_vect ) {
	static uint8_t cnt = 0;
/* Ausdokumentiert, da die LED gerade frs debugging gebraucht wird.
	if( errlvl == 0 )
		led_aus();
	else if( errlvl == 1 )
		led_an();
	else if( errlvl == 2 ) {
		if ( cnt < LED_CNT_TOP/2 )
			led_aus();
		else
			led_an();
	}
	else if( errlvl == 3 ) {
		if ( ( cnt >= LED_CNT_TOP/4 && cnt < LED_CNT_TOP/2 )  || ( cnt >= LED_CNT_TOP*3/4 ) )
			led_aus();
		else
			led_an();
	}
*/

	cnt++;
	if ( cnt >= LED_CNT_TOP )
		cnt = 0;
}



ISR ( TIM1_COMPA_vect ) {
	static uint16_t next_high = 0;
	
	if ( TCCR1A & (1<<COM1A0) ) {
		TCCR1A	&= ~(1<<COM1A0);
		OCR1A	+= set_pos_a;
	}
	else {
		OCR1A	= next_high;
		TCCR1A	|= (1<<COM1A0);
		next_high += SER_PERIOD;
	}

	if ( sig_good_cnt < 100 )
		sig_good_cnt++;

}


ISR ( TIM1_COMPB_vect ) {
	static uint16_t next_high = 32768; // 180 Phasenverschiebung

	if ( TCCR1A & (1<<COM1B0) ) {
		TCCR1A	&= ~(1<<COM1B0);
		OCR1B	+= set_pos_b;
	}
	else {
		OCR1B	= next_high;
		TCCR1A	|= (1<<COM1B0);
		next_high += SER_PERIOD;
	}

}
