#include <avr/io.h>

#include "interrupts.h"
#include "init.h"


volatile uint16_t read_pos = 1500;	// ber ICP eingelesenes Signal
volatile uint16_t set_pos_a = 1500; // Signal fr Servo 1
volatile uint16_t set_pos_b = 1500; // Signal fr Servo 2
volatile uint8_t sig_good_cnt = 100;// Zhler, der alle 20ms hochzhlt und bei jedem gltigen eingelesenen Signal zurckgesetzt wird.
volatile uint8_t errlvl = 1;		// Fehlercode; Zustnde:0-3 (aus, leuchten, blinken, schnell blingken)


int main ( void ) {
	
	init();

	while(1) {
		

		if ( sig_good_cnt == 0 ) {	// neuer gltiger Eingangswert gemessen

			set_pos_a = read_pos;	// gelesene Servostellung direkt bernehmen
			set_pos_b = read_pos;
			PORTA &= ~(1<<PA3);		// Motor darf an sein
			DDRB  |= (1<<PB2);		

			if ( errlvl != 0 )
				errlvl = 0;

			sig_good_cnt++;			// direkt eins weiterzhlen
		}

		if ( sig_good_cnt > FAIL_DELAY ) {	// Fehler; zu lange keine gltigen daten!

			set_pos_a = 1200;				// Fehlerposition anfahren
			set_pos_b = 1800;
			PORTA |= (1<<PA3);				// Motor aus!
			DDRB  &= ~(1<<PB2);
			errlvl = 1;
		}


	}
}



